## Open Solo - Post Installation Instructions ##
Regardless of installation method, this is what you will need to do next, leading up to flight. Consequently, this is also what you need to do after a parameter reset in the future if you need to.

1. **Level Calibration:** Use the _IMU Calibration_ function in the Solex app, or the _level calibration_ function in the 3DR or SidePilot apps, or the _3D Accel Calibration_ in Mission Planner, or the _Accelerometer Calibration_ in the Tower app to do the level calibration. They all do the same thing and just give it different names.  Reboot when complete.
   - The level calibration must be done on a solid, stable, level surface like a table or hard floor.
   - For each axis you calibrate, wait about 10 seconds after putting it down before pressing the button.
   - Make sure the solo is _perfectly still_ when you push the button each time.
   - The first step where it is right side up needs to be both _perfectly still and as level as you can make it_. The rest do not require perfect leveling.  Just being still.
   - Reboot when complete. The apps may not tell you to reboot. They may tell you to go fly. Reboot.

2. **Compass Calibration:** Use the _Compass Calibration_ function in The Solex app, SidePilot or 3DR app. Or use the _Onboard Compass Calibration_ in Mission Planner. They all do the same thing and just give it different names.  Reboot when complete.
   - Must be done outdoors
   - Must be done in an open area away from buildings, vehicles, reinforced concrete slabs, power lines, MRI machines, metal fencing, etc.
   - Remove any magnetic jewelry or steel accessories you may be wearing
   - Rotate the solo around each of its axes: Right side up, both sides, nose up, nose down, upside-down, etc. If you just spin it around level, it will fail. Keep spinning it around until it completes.
   - Reboot when when complete. The apps may not tell you to reboot. They may tell you to go fly. Reboot.

3. **Settings and Options:** Go through the _Vehicle Settings_ menu in Solex or the Solo settings in the 3DR app to set and verify all your settings and options.  You will need to set your RTH altitude, A & B buttons, geofence, max altitude, speed sliders, etc.  You can also change the WiFi SSID and password.

4. **FLY!** Find a safe open area to test fly the Solo. Ensure everything is operating as you expect and intend. Enjoy.
