#!/usr/bin/env python

# definitions of shots
# NOTE: Make sure this stays in sync with the app's definitions!  Those are in iSolo/UI/ShotLibrary.swift

APP_SHOT_NONE = -1
APP_SHOT_SELFIE = 0
APP_SHOT_ORBIT = 1
APP_SHOT_CABLECAM = 2
APP_SHOT_ZIPLINE = 3
APP_SHOT_RECORD = 4
APP_SHOT_FOLLOW = 5
APP_SHOT_MULTIPOINT = 6
APP_SHOT_PANO = 7
APP_SHOT_REWIND = 8
APP_SHOT_TRANSECT = 9
APP_SHOT_RTL = 10

# NULL terminated for sending to Artoo
SHOT_NAMES = {
    APP_SHOT_NONE : "FLY\0",
    APP_SHOT_SELFIE : "Selfie\0",
    APP_SHOT_ORBIT : "Orbit\0",
    APP_SHOT_CABLECAM : "Cable Cam\0",
    APP_SHOT_ZIPLINE : "Zip Line\0",
    APP_SHOT_FOLLOW : "Follow\0",
    APP_SHOT_MULTIPOINT: "Cable Cam\0",
	APP_SHOT_PANO: "Pano\0",
	APP_SHOT_REWIND: "Rewind\0",
	APP_SHOT_TRANSECT: "Transect\0",
	APP_SHOT_RTL: "Return Home\0",
}

CAN_START_BEFORE_ARMING = []
CAN_START_BEFORE_EKF = []
CAN_START_FROM_ARTOO = [APP_SHOT_ORBIT, APP_SHOT_CABLECAM, APP_SHOT_MULTIPOINT, APP_SHOT_PANO, APP_SHOT_ZIPLINE, APP_SHOT_REWIND, APP_SHOT_TRANSECT, APP_SHOT_RTL]
ALWAYS_NEEDS_APP_CONNECTION = [APP_SHOT_CABLECAM, APP_SHOT_SELFIE, APP_SHOT_ORBIT, APP_SHOT_FOLLOW, APP_SHOT_MULTIPOINT, APP_SHOT_PANO, APP_SHOT_ZIPLINE]
ALWAYS_NEEDS_RC_CONNECTION = [APP_SHOT_CABLECAM, APP_SHOT_SELFIE, APP_SHOT_ORBIT, APP_SHOT_FOLLOW, APP_SHOT_MULTIPOINT, APP_SHOT_PANO, APP_SHOT_ZIPLINE, APP_SHOT_TRANSECT]
SHOT_MODES = ['AUTO', 'GUIDED']
SITE_SCAN_SHOTS = [] # XXX remove
